//	author:	Barnabas Aszodi (BME-IIT)

#include "Ogre.h"
#include "OgreEffectWrapper.h"
#include "ManagedOgreRenderTexturePass.h"
#include "CAURenderPhotonUVMapPass.h"


CAURenderPhotonUVMapPass::CAURenderPhotonUVMapPass(
			Root* mRoot,const String& renderTextureName,unsigned int width,unsigned int height,
		 	TextureType texType , PixelFormat internalFormat ,
			const NameValuePairList *miscParams,
			bool fullScreenQuadRenderer):ManagedOgreRenderTexturePass(mRoot,renderTextureName,width,height,texType,internalFormat,miscParams,fullScreenQuadRenderer)
{
	effectWrapper->createMaterial("RenderPhotonUVMap");
}

void CAURenderPhotonUVMapPass::onRenderStart(NameValuePairList* namedParams){
	effectWrapper->SetTechniqueToUse(0);
	effectWrapper->BeginPass();
	effectWrapper->SetVertexProgramParameters();
	effectWrapper->SetMatrix("g_mWorldEntityMesh",g_mWorldEntityMesh);
	effectWrapper->SetMatrix("g_mWorldViewProj",g_mWorldViewProj);
	effectWrapper->SetVector3("g_vLightPos3f",g_vLightPos3f);
}

void CAURenderPhotonUVMapPass::onRenderEnd(NameValuePairList* namedParams)
{
	effectWrapper->EndPass();
}

Matrix4 CAURenderPhotonUVMapPass::getWorldEntityMesh()
{
	return g_mWorldEntityMesh;
}

void CAURenderPhotonUVMapPass::setWorldEntityMesh( Matrix4 matrix4 )
{
	g_mWorldEntityMesh = matrix4;
}

Matrix4 CAURenderPhotonUVMapPass::getWorldViewProj()
{
	return g_mWorldViewProj;
}

void CAURenderPhotonUVMapPass::setWorldViewProj( Matrix4 matrix4 )
{
	g_mWorldViewProj = matrix4;
}

Vector3 CAURenderPhotonUVMapPass::getLightPos3f()
{
	return g_vLightPos3f;
}

void CAURenderPhotonUVMapPass::setLightPos3f( Vector3 v )
{
	g_vLightPos3f = v;
}
